/*
 *  VCFto012s.h
 *  vcfReader
 *
 *  Created by Youna Hu on 2/3/11.
 *  Copyright 2011 U of Michigan. All rights reserved.
 *
 */

#ifndef __VCF_to_012s_h__
#define __VCF_to_012s_h__

#include <vector>
#include <map>
#include <set>
#include "StringBasics.h"
#include "StringArray.h"
#include <string> 
#include "DataFromFiles.h"
#include "Error.h"
#include <iostream>

class VcfTransform{
public:
	String m_vcfName;
	String m_subjectFile;
	int fileStep;
	String fileEntry;
	std::string searchNonsyn,searchStop;
	std::string annotationInfo;
	StringArray fileToken;
	StringArray genoToken;
	StringArray alleleToken;
	long int genoTypeNum;
	std::map<String, int> subjectColumn; // for all subjects, find their corresponding columns
	std::vector<String> subjectSelected; // contains the selected subjects given by IDfile
	std::vector<int> columnsSelected; // which columns are to be outputted, could be all, or a subset
	std::set<int> rowKeep;
	int genoColumn;
	long int genoSum;
	int nSample; // number of samples at each position without missing genotype
	bool sampleByPos;
	int genoStartCol,idCol,refCol,altCol,annotationCol;
	int nSubjects; // number of subjects -- note: This is different from nSamples
	int numPos; // number of samples
	bool posInclude;
	
	// Initializer
	void Init(String &vcfName, String &subjectsFile);
	
	// constructor
	VcfTransform(String &vcfName,String &subjectsFile);
	
	// destructor
	~VcfTransform();
	
	// subtract genotype from vcf
	bool IsMissing();
	
	// update the subjects related member variables
	void UpdateSubjects();
	void UpdateColumnSelected(String &subjectsFile, String &genofileName);
	// after I discovered that I will need to be able to extract variants based on given chr+start+end
	bool AnnotationSearch(String & fileEntryIn, int idx_to_search, String & searchKeys);
	bool PositionRangeSearch(String &fileEnetryIn, String chrNumber, int rangeStart, int rangeEnd);
	void VCFvariantsInclude(int posAll);
	void VCFvariantsInclude(int posAll, String &vGroups);	
	
	void VCF2TransformedGeno(String &genofileName, String &subjectsFile, int posAll, String &geneDef);	
	

};

#endif